# Mentorenwahl: A fullstack application for assigning mentors to students based on their whishes.
# Copyright (C) 2022  Dominic Grimm
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

module Backend
  module Mailers
    # Sends teacher a polite registration mail to ask if they may input their data
    class TeacherRegistrationMailer < Quartz::Composer
      def sender : Quartz::Message::Address
        address email: Backend.config.smtp.username, name: Backend.config.smtp.name
      end

      def initialize(user : Ldap::User)
        to name: user.name, email: user.email
        subject "Mentorenwahl Lehrer Registrierung"
        text Kilt.render("#{__DIR__}/templates/teacher_registration_mailer.txt.ecr")
      end
    end
  end
end
